--
-- PostgreSQL database dump
--

SET client_encoding = 'LATIN1';
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: xref_raw; Type: TABLE; Schema: public; Owner: scottauge; Tablespace: 
--

CREATE TABLE xref_raw (
    rec_id character varying NOT NULL,
    app_name character varying NOT NULL,
    procedure_name character varying NOT NULL,
    file_name character varying NOT NULL,
    line_number character varying NOT NULL,
    reference_type character varying NOT NULL,
    object_identifier character varying NOT NULL
);


ALTER TABLE public.xref_raw OWNER TO scottauge;

--
-- Name: TABLE xref_raw; Type: COMMENT; Schema: public; Owner: scottauge
--

COMMENT ON TABLE xref_raw IS 'Raw lines from a progress xref file';


--
-- Name: COLUMN xref_raw.rec_id; Type: COMMENT; Schema: public; Owner: scottauge
--

COMMENT ON COLUMN xref_raw.rec_id IS 'Unique identifier for the record';


--
-- Name: COLUMN xref_raw.app_name; Type: COMMENT; Schema: public; Owner: scottauge
--

COMMENT ON COLUMN xref_raw.app_name IS 'Name or version of the app xref is for';


--
-- Name: COLUMN xref_raw.procedure_name; Type: COMMENT; Schema: public; Owner: scottauge
--

COMMENT ON COLUMN xref_raw.procedure_name IS 'Procedure xref is for';


--
-- Name: COLUMN xref_raw.file_name; Type: COMMENT; Schema: public; Owner: scottauge
--

COMMENT ON COLUMN xref_raw.file_name IS 'File procedure is found in';


--
-- Name: COLUMN xref_raw.line_number; Type: COMMENT; Schema: public; Owner: scottauge
--

COMMENT ON COLUMN xref_raw.line_number IS 'Line number in file';


--
-- Name: COLUMN xref_raw.reference_type; Type: COMMENT; Schema: public; Owner: scottauge
--

COMMENT ON COLUMN xref_raw.reference_type IS 'See Progress COMPILE statement';


--
-- Name: COLUMN xref_raw.object_identifier; Type: COMMENT; Schema: public; Owner: scottauge
--

COMMENT ON COLUMN xref_raw.object_identifier IS 'See Progress COMPILE statement';


--
-- Name: xref_raw_rec_id_key; Type: CONSTRAINT; Schema: public; Owner: scottauge; Tablespace: 
--

ALTER TABLE ONLY xref_raw
    ADD CONSTRAINT xref_raw_rec_id_key UNIQUE (rec_id);


--
-- Name: xref_raw_app_ref; Type: INDEX; Schema: public; Owner: scottauge; Tablespace: 
--

CREATE INDEX xref_raw_app_ref ON xref_raw USING btree (app_name, reference_type);


--
-- PostgreSQL database dump complete
--


