<?php

/*************************************************************************

    XRef Analysis
    Copyright (C) 2007  Scott Auge and contributors 
    sauge@amduus.com scott_auge@yahoo.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
*************************************************************************/

/* 
$Log: parse_xref.php,v $
Revision 1.1  2007/05/22 06:40:49  sauge
Initial revision


*/


// Parse a given line from an xref file.  We simply send back an
// associative array for use in an SQL statement or what have you.

function parse_xref ($Line) {

  // TODO: If there is a space in the file name or the procedure name,
  // there will be quotes around them.  Right now, none of my paths 
  // have such beasties and so I don't account for this in the parsing
  // routine.

  $OffSet = strpos($Line, " ");
  $Parsed["procedure_name"] = substr($Line, 0, $OffSet); 
  $Line = substr($Line, $OffSet + 1);

  $OffSet = strpos($Line, " ");
  $Parsed["file_name"] = substr($Line, 0, $OffSet); 
  $Line = substr($Line, $OffSet + 1);

  $OffSet = strpos($Line, " ");
  $Parsed["line_number"] = substr($Line, 0, $OffSet); 
  $Line = substr($Line, $OffSet + 1);

  $OffSet = strpos($Line, " ");
  $Parsed["reference_type"] = substr($Line, 0, $OffSet); 
  $Line = substr($Line, $OffSet + 1);

  $Parsed["object_identifier"] = $Line;

  return $Parsed;

} // parse_xref();

/*****************
// Used for testing

$V = parse_xref ("/prg/101a/src/web/method/e4gl.i /prg/101a/src/web/method/cgidefs.i 74 STRING \"PATH_TRANSLATED\" 15 NONE UNTRANSLATABLE ");
print_v ($V);

$V = parse_xref("/appl/schdeve/source/sysmain.i /appl/schdeve/source/systools.i 77 FUNCTION StuTermDisp,CHARACTER,INPUT iStudentId INTEGER,INPUT iCourseSectionSeq INTEGER,INPUT cFomat CHARACTER");
print_v ($V);

$V = parse_xref("/appl/schdeve/source/sysmain.i /appl/schdeve/source/syslogin.i 9 ACCESS school.WebState SessionID ");
print_v($V);

function print_v ($V) {
  print ($V["procedure_name"] . "\n");
  print ($V["file_name"] . "\n");
  print ($V["line_number"] . "\n");
  print ($V["reference_type"] . "\n");
  print ($V["object_identifier"] . "\n");
  print ("\n\n");
} // print_v ()
****************/

?>
