<?php

/*************************************************************************

    XRef Analysis
    Copyright (C) 2007  Scott Auge and contributors 
    sauge@amduus.com scott_auge@yahoo.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
*************************************************************************/

/*
$Log: walk_propath.php,v $
Revision 1.1  2007/05/20 00:22:01  root
Initial revision


*/

include_once ("os_tools.php");

//************************************************************************
// Walk the propath that has xref files in it.  Use the Zammi
// propath compiler tool (or your own) to create the xref files.
//************************************************************************

function walk_propath ($FileName, $Propath) {

  if (detectos() == "unix") 
    walk_unix_propath ($FileName, $Propath);
  else
    walk_windows_propath ($FileName, $Propath);
  
} // walk_propath ()

//************************************************************************
// Walk a UNIX propath.
//************************************************************************

function walk_unix_propath ($FileName, $Propath) {

  // First determine if the propath is using a : or a , as it's delimiter

  $Delimiter = strpos($Propath, ",") != FALSE ? "," : ":";

  // Break up the propath and issue a UNIX find command to list out the
  // xref files.

  unlink($FileName);
  foreach (explode ($Delimiter, $Propath) as $Dir) {

    $Cmd = "find " . $Dir . " -name \"*.xref\" >> " . $FileName;
    print ("Issuing: $Cmd \n");
    
    exec ($Cmd, $Junk);
    unset ($Junk);

  } // foreach ()

} // walk_unix_propath ()

//************************************************************************
// TODO: Walk a windows propath 
//************************************************************************

function walk_windows_propath ($FileName, $Propath) {} ;

/*
// Used for testing

walk_propath ("/tmp/a", "/appl/schdeve/work:/appl/schdeve/source");
*/
?>
